# Created by pyp2rpm-3.3.5
%if 0%{?rhel}
%bcond_with docs
%else
%bcond_without docs
%endif
%bcond_without tests

%global pypi_name drgn

%global _description %{expand:
drgn (pronounced "dragon") is a debugger with an emphasis on programmability.
drgn exposes the types and variables in a program for easy, expressive
scripting in Python.}

Name:           python-%{pypi_name}
Version:        0.0.31+55.gddf90beb
Release:        1.20250617151200720809.pr506.55.gddf90beb%{?dist}
Summary:        Programmable debugger

License:        LGPL-2.1-or-later
URL:            https://github.com/osandov/drgn
Source0:        drgn-0.0.31+55.gddf90beb.tar.gz

BuildRequires:  python3-devel
BuildRequires:  python3dist(setuptools)
%if %{with docs}
BuildRequires:  sed
BuildRequires:  python3dist(sphinx)
BuildRequires:  python3-docs
BuildRequires:  graphviz
%endif
%if %{with tests}
BuildRequires:  python3dist(pytest)
%endif
BuildRequires:  gcc-c++
BuildRequires:  make
BuildRequires:  bzip2-devel
BuildRequires:  elfutils-devel
BuildRequires:  elfutils-debuginfod-client-devel
BuildRequires:  libkdumpfile-devel
BuildRequires:  zlib-devel
BuildRequires:  xz-devel
# These are needed when building from git snapshots
BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  libtool

%description %{_description}

%package -n     %{pypi_name}
Summary:        %{summary}
Recommends:     elfutils-debuginfod-client

%description -n %{pypi_name} %{_description}

%if %{with docs}
%package -n %{pypi_name}-doc
Summary:        %{pypi_name} documentation
BuildArch:      noarch
Requires:       python3-docs

%description -n %{pypi_name}-doc %{_description}

This package contains additional documentation for %{pypi_name}.
%endif

%prep
%autosetup -n drgn-0.0.31+55.gddf90beb -p1
# Remove bundled egg-info
rm -rf %{pypi_name}.egg-info
%if %{with docs}
# Use local intersphinx inventory
sed -r \
    -e 's|https://docs.python.org/3|%{_docdir}/python3-docs/html|' \
    -i docs/conf.py
%endif
# Ensure version is always set, even when building from git snapshots
if [ ! -f drgn/internal/version.py ]; then
  echo '__version__ = "%{version}"' > drgn/internal/version.py
fi

%build
# verbose build
V=1 %py3_build

%if %{with docs}
# generate html docs
PYTHONPATH=${PWD} sphinx-build-3 docs html
# remove the sphinx-build leftovers
rm -rf html/.{doctrees,buildinfo}
%endif

%install
%py3_install
mkdir -p %{buildroot}%{_datadir}/drgn
cp -PR contrib tools %{buildroot}%{_datadir}/drgn

%if %{with tests}
%check
%pytest
%endif

%files -n %{pypi_name}
%license COPYING
%license LICENSES
%doc README.rst
%{_bindir}/drgn
%{_datadir}/drgn
%{python3_sitearch}/_%{pypi_name}.pyi
%{python3_sitearch}/_%{pypi_name}.cpython*.so
%{python3_sitearch}/%{pypi_name}
%{python3_sitearch}/_%{pypi_name}_util
%{python3_sitearch}/%{pypi_name}-%{version}-py%{python3_version}.egg-info

%if %{with docs}
%files -n %{pypi_name}-doc
%license COPYING
%license LICENSES
%doc html
%endif

%changelog
* Tue Jun 17 2025 Packit <hello@packit.dev> - 0.0.31+55.gddf90beb-1.20250617151200720809.pr506.55.gddf90beb
- Enhance get_dmesg() and print_dmesg() (Yassine Larhrissi)
- execscript: Allow setting the globals (Stephen Brennan)
- docs: fix inserting local extensions into sys.path (Omar Sandoval)
- tools/fsrefs.py: add mode to find references to a Btrfs subvolume (Omar Sandoval)
- Add 6.16 to supported kernels (Omar Sandoval)
- vmtest.githubapi: work around urllib.request leaking Authorization header on redirect (Omar Sandoval)
- vmtest.vm: replace signal handler with setpriv --pdeathsig (Omar Sandoval)
- vmtest.vm: don't run interactively by default (Omar Sandoval)
- vmtest.vm: use contextlib.ExitStack to reduce context manager/try nesting (Omar Sandoval)
- vmtest.vm: use "b" magic sysrq instead of "o" (Omar Sandoval)
- vmtest/kbuild: add patch to make emergency reboot quieter on old Arm kernels (Omar Sandoval)
- tests: add @skip_unless_have_test_kmod to test_is_pp_page() (Omar Sandoval)
- tests: add test for drgn.helpers.linux.net.is_pp_page() (Omar Sandoval)
- drgn.helpers.linux.net: raise NotImplementedError when is_pp_page() can't work (Omar Sandoval)
- vmtest.kbuild: add patch to enable CONFIG_PAGE_POOL on old kernels (Omar Sandoval)
- tests: skip .gnu_debugdata tests if not built with lzma support (Omar Sandoval)
- cli: add lzma support to version string (Omar Sandoval)
- libdrgn: python: factor out adding booleans to module (Omar Sandoval)
- scripts/build_manylinux_in_docker.sh: explicitly enable lzma support (Omar Sandoval)
- libdrgn: configure: rename --with-liblzma to --with-lzma (Omar Sandoval)
- vmtest.rootfsbuild: install liblzma-dev (Omar Sandoval)
- docs: document optional liblzma dependency (Omar Sandoval)
- tests: skip timekeeping tests using time.clock_gettime_ns() on Python 3.6 (Omar Sandoval)
- drgn.helpers.linux.timekeeping: make ktime helpers less racy (Omar Sandoval)
- tests: Add tests for .gnu_debugdata symbol tables (Stephen Brennan)
- elf_symtab: add support for .gnu_debugdata (Stephen Brennan)
- elf_symtab: support multiple tables per module (Stephen Brennan)
- docs: fix escape sequences in docstrings (Omar Sandoval)
- Separate debug info options for directories and debug link directories (Omar Sandoval)
- libdrgn: linux_kernel: add all address ranges for kernel modules (Omar Sandoval)
- Support multiple address ranges per module (Omar Sandoval)
- pre-commit: update flake8, mypy, and pre-commit-hooks (Omar Sandoval)
- pre-commit: drop --no-warn-unused-ignores from mypy (Omar Sandoval)
- drgndoc: remove unused need_blank_line variable (Omar Sandoval)
- drgn.helpers.linux: add timekeeping helpers (Omar Sandoval)
- pre-commit: bump vermin target to Python 3.8 (Omar Sandoval)
- drgn.helpers.linux.cpumask: add cpumask_weight() and num_*_cpus() helpers (Omar Sandoval)
- drgn.helpers.linux.bitmap: add bitmap_weight() helper (Omar Sandoval)
- drgn.helpers.linux.bitops: use operator.index() instead of int() (Omar Sandoval)
- docs: sort experimental helpers after others (Omar Sandoval)
- docs: update required Sphinx version to 8.1.3 (Omar Sandoval)
- drgn.helpers.linux.mm: fix for_each_vmap_area() example (Omar Sandoval)
- libdrgn: elf_symtab: fix overriding partial table with full table (Omar Sandoval)
- docs: clarify Program.symbol() tie-breaking (Omar Sandoval)
- libdrgn: elf_symtab: fix comment about skipping local symbols (Omar Sandoval)
- libdrgn: python: add missing garbage collection support (Omar Sandoval)
- libdrgn: python: check correct pointer in StackTrace_dealloc() (Omar Sandoval)
- libdrgn: python: fix reference leak for held types (Stephen Brennan)
- contrib/pp_leak: add page_pool leak debug scripts (Dragos Tatulea)
- helpers: add is_pp_page helper (Dragos Tatulea)
- drgn.helpers.linux.fs: skip cursors in for_each_mount() (Stephen Brennan)
- vmtest.rootfsbuild: install check (Omar Sandoval)
- cli: don't enter interactive mode for empty -e argument (Omar Sandoval)
- tests: fix issues with CLI test error handling (Omar Sandoval)
- tests: fix deserialize_struct64 tests on i386 (Omar Sandoval)
